<%@ Language=VBScript %>
<html>
<head>
	<title>Banner Ad</title>
</head>
<body>
<table width="650">
<tr>
	<td>

<h1>Simple Banner Ad System</h1>

<p>&nbsp;&nbsp;&nbsp; There may be a point in your web design career, where your site becomes real 
popular.  That is when companies become interested in advertising on your site. A 
Banner Ad system can be built to control all those advertisements that you are so 
willing to display, for a price. Active Server Pages 
makes it very easy to create a banner ad system. So easy, that the Microsoft ASP 
developers created an "AdRotator" component for the occasion. Before you begin reading this article, 
make sure you download the support material below.</p>

<p><a href="banner.zip" title="Banner Ad System Files">Banner System</a>

<h3>The files included are</h3>

<samp>
ad.txt<br>
banner.asp<br>
3 banner images<br>
clicks.asp<br>
example.asp<br>
redirect.asp<br>
</samp>

<h3>ad.txt</h3>

<p>&nbsp;&nbsp;&nbsp; 
In order for the AdRotator component to work, you must configure a text file. This 
text file contains all the banner ad properties. However, The text file must follow a certain 
format. The first four lines are as follows...</p>

<pre>
REDIRECT redirect.asp
WIDTH 400
HEIGHT 50
*
</pre>

<strong>REDIRECT</strong>
<p>&nbsp;&nbsp;&nbsp; When a banner is clicked, the "AdRotator" component goes to a preliminary page. 
This page is called a redirect page. The redirect page handles any extra programming events
before directing a user to the banners destination. In this example banner system, I called the 
prelinimary file "redirect.asp".</p>

<strong>WIDTH</strong>
<p>&nbsp;&nbsp;&nbsp; This sets the width of the banner ad image. The value must be in pixels.</p>

<strong>HEIGHT</strong>
<p>&nbsp;&nbsp;&nbsp; This sets the height of the banner ad image. The value must be in pixels.</p>
<strong>*</strong>
<p>&nbsp;&nbsp;&nbsp; 
The asterisk tells the "AdRotator" component that it is about to aquire banner ad information.
The asterisk is required.
</p>
<hr>
<p>&nbsp;&nbsp;&nbsp; 
Once you define the general properties above the asterisk, then comes the list of 
banners to display. In the <em>ad.txt</em> file, there are three banners defined below the 
asterisk.</p>

<pre>
banner1.jpg
http://www.htmlgoodies.com
HTMLGoodies.com
20
banner2.jpg
http://www.yahoo.com
Yahoo.com
30
banner3.jpg
http://www.dogpile.com
Dogpile.com
30
</pre>

<p>&nbsp;&nbsp;&nbsp; 
Each banner requires four lines of properties, which follow the format below...</p>

<pre>
Image filename
Web Address 
Description
Banner Weight
</pre>

<strong>Image File</strong>
<p>&nbsp;&nbsp;&nbsp; The image filename can be a fully qualified web address or relative name that points to
the image. If the image is in a different folder, then you also include the folder 
name as well.(http://www.test.com/banner1.jpg, banner1.jpg, or foldername/banner.jpg)></p>

<strong>Web Address</strong>
<p>&nbsp;&nbsp;&nbsp; The web address can be a page on your site or a fully qualified web address that 
leads to another site.</p>

<strong>Description</strong>
<p>&nbsp;&nbsp;&nbsp; The description will be displayed as a tool tip. When you rest your mouse over the 
banner, the description pops up.</p>

<strong>Banner Weight</strong>
<p>&nbsp;&nbsp;&nbsp; The banner weight determines how much a banner is displayed. The "AdRotator" 
component adds all of the banner weights and determines the probability or percent 
chance of a particular banner being displayed. A banner with a higher weight has
better a better probability.</p>

<strong>NOTE:</strong> You can disable a banners property by substituting with a dash.

<pre>
banner3.jpg
-
Dogpile.com
30
</pre>
<p>
&nbsp;&nbsp;&nbsp; The example entry above would create a banner ad that does not have
a web address.</p>

<h3>Banner.asp</h3>

<p>&nbsp;&nbsp;&nbsp; This file uses the "AdRotator" component and analyzes the 
contents of the <em>ad.txt</em> file. Below is the code.</p>

<code>
sub banner(strTarget)<br>
&nbsp;&nbsp;&nbsp;dim bannerad, html<br>
&nbsp;&nbsp;&nbsp;set bannerad = server.CreateObject("MSWC.adrotator")<br>
&nbsp;&nbsp;&nbsp;bannerad.TargetFrame = strTarget<br>
&nbsp;&nbsp;&nbsp;html = bannerad.GetAdvertisement("ad.txt")<br>
&nbsp;&nbsp;&nbsp;Response.Write html<br>
end sub
</code>

<p>&nbsp;&nbsp;&nbsp; The first thing to note is that the ASP was written with VBScript. The 
second thing to note is that the code is written inside a sub procedure called 
<dfn>banner(strTarget)</dfn>. For those of you who do not know, a sub procedure allows you to group 
together a bunch of code that can be reused over and over. Like a function, it takes 
an argument, such as a word or variable. In the code above the argument is <dfn>strTarget</dfn>.  Unlike a function, a 
sub-procedure does not return any values, it just executes the code inside line by 
line.</p>

<p>&nbsp;&nbsp;&nbsp; Inside the sub I declare two variables...</p>
	
<code>dim bannerad, html</code>

<p>&nbsp;&nbsp;&nbsp; Next I store the "AdRotator" component inside the "bannerad" variable. When storing a 
component inside a variable you use the <dfn>set</dfn> keyword. Since we are programming 
server-side with ASP, we use <em>server.CreateObject</em> to summon the component. 
"MSWC.adrotator" is the component key or name value.</p>

<code>set bannerad = server.CreateObject("MSWC.adrotator")</code>

<p>&nbsp;&nbsp;&nbsp; Next I use a property of the "AdRotator" called "TargetFrame". 
This property is equivalent to...</p>

<code>&lt;a href="http://www.someaddress.com" target="target-value"&gt;</code>

<p>&nbsp;&nbsp;&nbsp; The target-value can be one of the values below...</p>

<table border="1" width="500">
<colgroup>
	<col width="120">
	<col width="380">
<tr>
	<td>_blank</td>
	<td>Opens the destination link in a new browser window.</td>
</tr>
<tr>
	<td>_top</td>
	<td>Opens the destination link on top of the web page.</td>
</tr>
<tr>
	<td>_parent</td>
	<td>Opens the destination link within a parent frame.</td>
</tr>
<tr>
	<td>_new</td>
	<td>Opens the destination link in a new browser window.</td>
</tr>
</table>
_blank
_top
_parent
_new
</pre>

<p>&nbsp;&nbsp;&nbsp; Next, I use an "AdRotator" method or function called "GetAdvertisement" and stored its 
results in the "html" variable. Notice that the "GetAdvertisement" takes the name of 
the ad banner text file as an argument.</p>

<code>html = bannerad.GetAdvertisement("ad.txt")</code>

<p>&nbsp;&nbsp;&nbsp; Finally, I want to print the contents of the "html" variable.
This prints the code that displays the banner images.</p>

<code>Response.Write html</code>

<h3>Redirect.asp</h3>

<p>&nbsp;&nbsp;&nbsp; This is the file that is processed before someone is redirected to the banners web 
address. Inside this file, we can capture information like how many times a particular
banner is clicked and so on. To start things off, I defined a variable called "strUrl".</p>

<code>Dim strUrl</code>

<p>&nbsp;&nbsp;&nbsp; Next I store a querystring value inside this new variable.</p>

<code>strUrl = Request.Querystring("url")</code>

<p>&nbsp;&nbsp;&nbsp; A querystring is nothing more than a bunch of name/value pairs 
attached to a web address. When a user clicks on a banner, the "AdRotator" component 
attaches a querstring to the redirect file. So if we were to click banner1.jpg, 
defined in <em>ad.txt</em>, we would end up with a redirect web address that looks like so...</p>

<samp>Redirect.asp?url=http://www.htmlgoodies.com&image=banner1.jpg</samp>

<p>&nbsp;&nbsp;&nbsp; In essence assigning "Request.Querystring("url") to "strUrl", is the same as 
assigning http://www.htmlgoodies.com to it.</p>

<p>&nbsp;&nbsp;&nbsp; Finally, I check to see which banner was clicked. I accomplish this with the VBSCript 
inStr( ) function.</p> 

<code>
if instr(strUrl, "htmlgoodies") then<br>
&nbsp;&nbsp;&nbsp;Application.Lock<br>
&nbsp;&nbsp;&nbsp;application("htmlgoodies") = application("htmlgoodies") + 1<br>
&nbsp;&nbsp;&nbsp;Application.UnLock<br>
&nbsp;&nbsp;&nbsp;Response.Clear<br>
&nbsp;&nbsp;&nbsp;Response.Redirect strUrl<br>
end if
</code>

<p>&nbsp;&nbsp;&nbsp; The inStr( ) function returns the number position of a sub-word (sub-string)
within another word (string). The format is as follows</p>

<samp>InStr(main word, sub-word)</samp>

<p>&nbsp;&nbsp;&nbsp; If the sub-word exist within the main word, then the function 
will equal a number greater-than zero or true. If the sub-word does not exist, then the 
function will equal zero or false. In the example above, I check to see if "htmlgoodies" 
exist within http://www.htmlgoodies.com. Since the answer is true, then the code 
inside the <code>if... then...</code> statement will execute.</p>

<p>&nbsp;&nbsp;&nbsp; Inside the <code>if... then...</code> I use an application variable. An application variable is 
native to ASP. Application variables store information as long as a web application 
exist, a web application ceases to exist when say someone shuts off the web hosting server.
The beauty of an application variable is that you can define it on one web page 
and use it in other web pages within your web application. The downfall is that the users computer must 
have cookies enabled.</p>

<p>&nbsp;&nbsp;&nbsp; Anyways, the code adds one to the application variable, every time a banner is 
clicked. After one is added, the code redirects to the banners web 
page. So if banner1 was clicked then you shall be redirected to "http://www.htmlgoodies.com".</p>

<code>Response.Redirect strUrl</code>

<h3>Example.asp</h3>

<p>&nbsp;&nbsp;&nbsp; This is an example page that uses the bannerad system. When you 
refresh the page, you should most likely see a different banner. Whenever you want to 
insert the banner ad on a page, you can use the SSI directive below...</p>

&lt;!-- #include file="banner.asp" --&gt;

<p>&nbsp;&nbsp;&nbsp; Once you include the file above, then you can call the 
sub-procedure inside the banner.asp file like so...</p>

<code>Call banner("_blank")</code>

<p>&nbsp;&nbsp;&nbsp; Notice that I supply one of the values for the "TargetFrame" as an
argument. So if the banner is clicked, then the web page should open up in a separte
browser window.</p>

<h3>Clicks.asp</h3>

<p>&nbsp;&nbsp;&nbsp; This is a very simple page that displays the number of clicks 
per banner ad. To display the number of times a banner was clicked, you just print the 
contents of the application variables that were created inside "redirect.asp". Pretty
nifty.</p>

<code>&lt;% =application("htmlgoodies") %&gt;</code>
	</td>
</tr>
</table>
</body>
</html>
